// Name: Files Since Last Call (FSLC) v1.0
// for Mystic BBS v1.10+
// By Darryl Perry, aka Gryphon of Cyberia BBS
// telnet://cyberia.darktech.org
// Install: 
//     1) Place fslc.mps file in mystic scripts dir.
//     2) Compile with MIDE or MPLC
//     3) Add it to your login menu
//
// Changes:
// 
// 03/22/15  First Release 

Uses Cfg
Uses User
Uses FBase
Uses FGroup

Type
  RecFileList = Record
  FileName  : String[70];
  Size      : LongInt;
  DatTim    : LongInt;
  Uploader  : String[30];
  Flags     : Byte;
  Downloads : LongInt;
  Rating    : Byte;
  DescPtr   : LongInt;
  DescLines : Byte;
End;

Var Files  : RecFileList
Var FBTot,TotFiles  : Integer
Var Ok  : Boolean = True

Function ReadListEntry(FN:String;I:Integer):Boolean
Var Ret  : Boolean=False
Var Fp  : File
Begin
  fAssign(Fp,CfgDataPath+FN+'.dir',66)
  fReset(Fp)
  If IoResult = 0 Then Begin
    fSeek(Fp,(I-1)*SizeOf(Files))
    If Not fEof(Fp) Then Begin
      fReadRec(Fp,Files)
      Ret:=True
    End
    fClose(Fp)
  End  
  ReadListEntry:=Ret
End

Procedure Main(Pass:Integer)
Var Done  : Boolean = False
Var I,G,H  : Integer
Var S      : String
Begin
  TotFiles:=0
  G:=1 // Iterate through each group
  While GetFGroup(G) And ACS(FGroupACS) Do Begin
    MenuCmd('FG',Int2Str(G))
    H:=1 // Iterate through each base again
    While GetFBase(H) And ACS(FBaseACS) Do Begin
      I:=0
      FBTot:=0
      While ReadListEntry(FBaseFN,I+1) Do Begin
      If Files.DatTim >= UserLastOn Then Begin
          TotFiles:=TotFiles+1
          FBTot:=FBTot+1
        End
        I:=I+1
      End
      If FBTot > 0 And Pass = 2 Then
        WriteLn('|14'+PadLt(Int2Str(FBTot),5,' ')+ '|11 new file(s) in ' + FBaseName)
      H:=H+1
    End
    G:=G+1
  End
End

Begin
  GetThisUser
  Main(1) // First pass to see if any files are new
  If TotFiles > 0 Then Begin // Do this only if there are new files
      WriteLn('|CR |11:|03:|07: There are '+Int2Str(TotFiles)+' new files since your last visit|08:|CR')
      Main(2) // Second pass to show the file count per base
  End
End
